public OnClientPostAdminCheck(client)
{
	SetAndMaintainSlots();
	VoteType[client] = 0;
	FriendlyFire[client] = 0;
	Rotation[client] = 0;
	bFlyCooldown[client] = false;
	bEnsnared[client] = false;
	new String:text[128];
	if (IsClientConnected(client) && IsClientHuman(client))		// we don't load data if the next map is loading
	{
		new SurvivorCount = 0;
		new InfectedCount = 0;

		new count = 0;
		for (new i = 1; i <= MaxClients; i++)
		{
			if (!IsClientHuman(i) || i == client) continue;
			if (GetClientTeam(i) == TEAM_SURVIVORS) SurvivorCount++;
			else if (GetClientTeam(i) == TEAM_INFECTED) InfectedCount++;
			Checked[i] = false;
			count++;
		}
		if (count >= GetConVarInt(g_Module_ReserveSettings_TotalSlots) - GetConVarInt(g_Module_ReserveSettings_ReserveSlots) + Spectators)
		{
			// all available slots are taken. Check if reserve, and if not, remove player.
			if (!IsReserve(client) && !IsAdmin(client))
			{
				// Not an admin, not a donator. No available slots. Remove.
				Format(text, sizeof(text), "%T", "Reserve Kick", client);
				KickClient(client, "%s", text);
			}
			else
			{
				new RandomClient = 0;
				count = 0;
				while (RandomClient == 0 && ValidKickClients() > 0)
				{
					RandomClient = GetRandomInt(1, MaxClients);
					if (!IsClientHuman(RandomClient) || Checked[RandomClient]) RandomClient = 0;
					else if (IsAdmin(RandomClient) || IsReserve(RandomClient) || RandomClient == client)
					{
						// Admins and donators can't be removed, and we can't count the client attempting to connect.
						Checked[RandomClient] = true;
						count++;
						if (count >= GetConVarInt(g_Module_ReserveSettings_TotalSlots) - GetConVarInt(g_Module_ReserveSettings_ReserveSlots) + Spectators)
						{
							// There are no eligible players to remove for the admin or donator, so we don't let them in.
							Format(text, sizeof(text), "%T", "No Eligible Slots", client);
							KickClient(client, "%s", text);
						}
						else RandomClient = 0;
					}
					else
					{
						Format(text, sizeof(text), "%T", "Reserve Kick For Contributor", client);
						KickClient(RandomClient, "%s", text);
					}
				}
			}
		}
		//if (IsClientConnected(client) && IsClientHuman(client))
		if (IsClientConnected(client) && !CheckForLoading[client])		// We check if they're connected in case they were kicked for no available slots.
		{
			CheckForLoading[client] = true;
			if (!bTransition) bAway[client] = false;			// it's a new client if they're connecting after all clients have loaded (or they're super slow)
			ChangeClientTeam(client, 1);
			if (!IsResourcing[client])
			{
				ClearPlayerData(client);
				IsResourcing[client] = true;
				CreateTimer(1.0, Timer_CheckForLoading, client, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			}
		}
	}
}

public Action:Timer_CheckForLoading(Handle:timer, any:client)
{
	if (!IsClientActual(client)) return Plugin_Stop;
	if (!IsClientStillLoading(client))
	{
		g_PingViolation[client] = 0;
		IsResourcing[client] = false;
		CheckForLoading[client] = false;
		bLoadAttempted[client] = false;
		MakeATeamDecision(client);
		LoadPlayerData(client);
		SDKHook(client, SDKHook_OnTakeDamage, OnTakeDamage);
		return Plugin_Stop;
	}
	return Plugin_Continue;
}

stock bool:IsClientStillLoading(client)
{
	if (IsClientConnected(client) && !IsClientInGame(client) && !IsFakeClient(client)) return true;
	return false;
}

stock ValidKickClients()
{
	new count = 0;
	for (new client = 1; client <= MaxClients; client++)
	{
		if (IsClientHuman(client) && !IsReserve(client) && !IsAdmin(client)) count++;
	}
	return count;
}

public OnClientDisconnect(client)
{
	if (IsClientConnected(client) && IsClientHuman(client))
	{
		g_PingViolation[client] = 0;
		CheckForLoading[client] = false;
		if (!bTransition)			//	Client disconnected when it was not a map transition; This is a true client disconnect.
		{
			bAway[client] = false;
			if (!bRoundOver)
			{
				CreateTimer(1.0, Timer_KickSurvivorBot_Post, client, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
			}
		}
		bFlyCooldown[client] = false;
		if (!bRoundOver)
		{
			CheckTeams(client);	// so we know whether the teams need to be balanced or not.
			if (GetClientTeam(client) == TEAM_SURVIVORS) SurvivorRoundsPlayed[client]++;
			else if (GetClientTeam(client) == TEAM_INFECTED) InfectedRoundsPlayed[client]++;
		}
		if (IsResourcing[client])
		{
			IsResourcing[client] = false;
		}
		bLoadAttempted[client] = false;
		SavePlayerData(client);
		SDKUnhook(client, SDKHook_OnTakeDamage, OnTakeDamage);
	}
}

/*public OnClientDisconnect_Post(client)
{
	CreateTimer(1.0, Timer_KickSurvivorBot, _, TIMER_FLAG_NO_MAPCHANGE);
}*/

public Action:Timer_KickSurvivorBot_Post(Handle:timer, any:client)
{
	if (bTransition || bRoundOver || IsKickingBots) return Plugin_Stop;
	if (!IsClientActual(client))
	{
		if (!IsVersus() || IsVersus() && GetConVarInt(g_SurvivorBots_KickOnDisconnect) == 1)
		{
			LogToFile(LOGFILE, "[Timer] KickSurvivorBot_Post - Removing eligible bots.");
			KickSurvivorBots();
		}
		if (IsVersus())
		{
			if (GetConVarInt(g_Debug) == 1) LogToFile(LOGFILE, "[AutoTeamBalance] Taking a look at the teams...");
			AutoTeamBalancer();
		}
		return Plugin_Stop;
	}
	return Plugin_Continue;
}

stock AutoTeamBalancer()
{
	if (!IsVersus()) return;
	new TargetTeam = IsTeamCountUnbalanced(true);
	new IgnoreTeam = IsTeamCountUnbalanced(false);
	if (IgnoreTeam > 0)	// This value is only 0 if the teams are even, or it is not possible to give each team an even number of players.
	{
		for (new i = 1; i <= MaxClients; i++)
		{
			if (!IsClientHuman(i)) continue;
			GetClientRank(i);
		}

		new RankLowPosition			= 0;
		new RankHighPosition		= RankMaximum;

		new RankPosition			=	0;
		if (GetConVarInt(g_Debug) == 1) LogToFile(LOGFILE, "[AutoTeamBalance] Highest Rank: %d", RankMaximum);

		if (bTeamsFlipped && TargetTeam == TEAM_SURVIVORS ||
			!bTeamsFlipped && TargetTeam == TEAM_INFECTED)
		{
			if (TM_GetCampaignScore(1) >= TM_GetCampaignScore(0)) RankPosition = RankHighPosition;
			else RankPosition = RankLowPosition;
		}
		else if (bTeamsFlipped && TargetTeam == TEAM_INFECTED ||
			!bTeamsFlipped && TargetTeam == TEAM_SURVIVORS)
		{
			if (TM_GetCampaignScore(0) >= TM_GetCampaignScore(1)) RankPosition = RankHighPosition;
			else RankPosition = RankLowPosition;
		}

		new client	=	-1;
		while (client == -1 && IsValidTeamPlayers(IgnoreTeam))
		{
			while (IsValidTeamPlayersAtRank(IgnoreTeam, RankPosition))
			{
				client	=	GetRandomInt(1, MaxClients);
				if (!IsClientHuman(client) || GetClientTeam(client) == TargetTeam || Rank[client] != RankPosition || (IgnoreTeam == 3 && FindZombieClass(client) == ZOMBIECLASS_TANK)) client = -1;
				else
				{
					// we show a message on-screen, since otherwise the player wouldn't see it.
					JoinTargetTeam(client, TargetTeam);
					new String:Name[512];
					GetClientName(client, Name, sizeof(Name));
					if (TargetTeam == TEAM_SURVIVORS) PrintToChatAll("%t", "Player Forced Survivor Team", white, blue, Name, green);
					else PrintToChatAll("%t", "Player Forced Infected Team", white, orange, Name, green);
				}
			}
			if (bTeamsFlipped && TargetTeam == TEAM_SURVIVORS ||
			!bTeamsFlipped && TargetTeam == TEAM_INFECTED)
			{
				if (TM_GetCampaignScore(1) >= TM_GetCampaignScore(0)) RankPosition--;
				else RankPosition++;
			}
			else if (bTeamsFlipped && TargetTeam == TEAM_INFECTED ||
				!bTeamsFlipped && TargetTeam == TEAM_SURVIVORS)
			{
				if (TM_GetCampaignScore(0) >= TM_GetCampaignScore(1)) RankPosition--;
				else RankPosition++;
			}
		}
		if (client == -1) KickSurvivorBots();
	}
}